<?php
/**
 * @brief		videoboxUpdateStreams Task
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - SVN_YYYY Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Social Suite
 * @subpackage	videobox
 * @since		22 Sep 2015
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\videobox\tasks;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * videoboxUpdateStreams Task
 */
class _videoboxUpdateStreams extends \IPS\Task
{
	public function execute()
	{
		if ( \IPS\Settings::i()->vb_conf_lv_on == 1 && \IPS\Settings::i()->vb_conf_lv_services )
		{
			$TwitchRunning = 0;
			$SmashcastRunning = 0;
			$MixerRunning = 0;
			
			foreach( \IPS\Db::i()->select( '*', 'core_queue' ) as $row )
			{
				if ( $row['key'] == 'vbUpdateTwitch' )
				{
					$TwitchRunning = 1;
				}
				if ( $row['key'] == 'vbUpdateSmashcast' )
				{
					$SmashcastRunning == 1;
				}
				if ( $row['key'] == 'vbUpdateMixer' )
				{
					$MixerRunning == 1;
				}				
			}
			
			if ( $TwitchRunning == 0 && in_array( "twitch", explode( ',', \IPS\Settings::i()->vb_conf_lv_services ) ) )
			{
				\IPS\Task::queue( 'videobox', 'vbUpdateTwitch', array(), 2 );
			}
			
			if ( $SmashcastRunning == 0 && in_array( "smashcast", explode( ',', \IPS\Settings::i()->vb_conf_lv_services ) )  )
			{
				\IPS\Task::queue( 'videobox', 'vbUpdateSmashcast', array(), 2 );
			}			
			
			if ( $MixerRunning == 0 && in_array( "mixer", explode( ',', \IPS\Settings::i()->vb_conf_lv_services ) )  )
			{
				\IPS\Task::queue( 'videobox', 'vbUpdateMixer', array(), 2 );
			}			
		}
		
		return NULL;
	}
	
	/**
	 * Cleanup
	 *
	 * If your task takes longer than 15 minutes to run, this method
	 * will be called before execute(). Use it to clean up anything which
	 * may not have been done
	 *
	 * @return	void
	 */
	public function cleanup()
	{
		
	}
}