<?php
/**
 * @brief		TopPosters Widget
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - SVN_YYYY Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Social Suite
 * @subpackage	videobox
 * @since		04 Jan 2015
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\videobox\widgets;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * topPoster Widget
 */
class _TopPosters extends \IPS\Widget
{
	/**
	 * @brief	Widget Key
	 */
	public $key = 'TopPosters';
	
	/**
	 * @brief	App
	 */
	public $app = 'videobox';
		
	/**
	 * @brief	Plugin
	 */
	public $plugin = '';
	
	/**
	 * Initialise this widget
	 *
	 * @return void
	 */ 
	public function init()
	{
		parent::init();
		// Use this to perform any set up and to assign a template that is not in the following format:
		// $this->template( array( \IPS\Theme::i()->getTemplate( 'widgets', $this->app, 'front' ), $this->key ) );
	}
	
	/**
	 * Specify widget configuration
	 *
	 * @param	null|\IPS\Helpers\Form	$form	Form object
	 * @return	null|\IPS\Helpers\Form
	 */
	public function configuration( &$form=null )
	{
 		if ( $form === null )
 		{
	 		$form = new \IPS\Helpers\Form;
 		} 
 		
		$form->add( new \IPS\Helpers\Form\Number( 'number_to_show', isset( $this->configuration['number_to_show'] ) ? $this->configuration['number_to_show'] : 5, TRUE ) );
		return $form;
 	} 
 	
 	 /**
 	 * Ran before saving widget configuration
 	 *
 	 * @param	array	$values	Values from form
 	 * @return	array
 	 */
 	public function preConfig( $values )
 	{
 		return $values;
 	}

	/**
	 * Render a widget
	 *
	 * @return	string
	 */
	public function render()
	{
		// foreach ( array( 'week' => 'P1W', 'month' => 'P1M', 'year' => 'P1Y', 'all' => NULL ) as $time => $interval )
		// {
			// $select = \IPS\Db::i()->select( 'core_members.*, videobox_videos.v_author, COUNT(*) AS videos, AVG(v_rating_average) as rating', 'videobox_videos', $interval ? array( 'v_started>? and v_author != ?', \IPS\DateTime::create()->sub( new \DateInterval( $interval ) )->getTimestamp(), 0 ) : array( 'v_author != ? and v_rating_average > ?', 0, 0 ), 'videos DESC', isset( $this->configuration['number_to_show'] ) ? $this->configuration['number_to_show'] : 9, 'v_author' )->join( 'core_members', 'videobox_videos.v_author=core_members.member_id' );
			// ${$time} = array();
			
			// foreach( $select as $key => $values )
			// {
				// ${$time}[$key]['member'] = \IPS\Member::constructFromData( $values );
				// ${$time}[$key]['videos']  = $values['videos'];
				// ${$time}[$key]['rating'] = $values['rating'];
			// }
		// }

		return $this->output( $week, $month, $year, $all );
	}
}